// --------------------------------------------------------------------------------------
//
// Hilbert.CS                                                      Ulrich Mller 22.01.05
//                                                                 PCS1700       C# Final
// Hilbert-Graphik
//
// --------------------------------------------------------------------------------------

using System;
using System.Windows.Forms;
using System.Drawing;

namespace DivGraph {

	// --- Hilbert -------------------------------------------------------------

	public class Hilbert : UrGraf {
		int tiefe, breite;
		float h, X1, Y1;
		public Hilbert(Control Ausgabe) : base(Ausgabe) {
			this.tiefe = 5;
			this.breite = Ausgabe.Width;
		}
		public int Tiefe {
			get {return tiefe;}
			set {tiefe = value;}
		}
		public int Breite {
			get {return breite;}
			set {breite = value;}
		}

		public override void Action(Graphics Canvas) {
			base.canvas = Canvas;
			base.canvas.Clear(base.background);
			int i = 0;
			int j = 1;
			float X0 = (breite / 2) + ((ausgabe.Width - breite) / 2);
			float Y0 = (breite / 2) + ((ausgabe.Height - breite) / 2);
			h = breite;

			do {
				i++; j *= 2;
				h = (breite / j);
				X0 += (h / 2);
				Y0 += (h / 2);
				X1 = X0;
				Y1 = Y0;
				procA(i);
			} while (i < tiefe);
		}
		private void procA(int i) {
			if(i == 0) return;
			procD(i-1);
			canvas.DrawLine(stift, X1, Y1, X1-h, Y1);  
			X1 -= h; 
			procA(i-1);
			canvas.DrawLine(stift, X1, Y1, X1, Y1-h);  
			Y1 -= h; 
			procA(i-1);
			canvas.DrawLine(stift, X1, Y1, X1+h, Y1);  
			X1 += h;
			procB(i-1);
		}
		private void procB(int i) {
			if(i == 0) return;
			procC(i-1);
			canvas.DrawLine(stift, X1, Y1, X1, Y1+h);
			Y1 += h;
			procB(i-1);
			canvas.DrawLine(stift, X1, Y1, X1+h, Y1);
			X1 += h;
			procB(i-1);
			canvas.DrawLine(stift, X1, Y1, X1, Y1-h);    
			Y1 -= h;
			procA(i-1);
		}
		private void procC(int i) {
			if(i == 0) return;
			procB(i-1);
			canvas.DrawLine(stift, X1, Y1, X1+h, Y1);
			X1 += h;
			procC(i-1);
			canvas.DrawLine(stift, X1, Y1, X1, Y1+h);
			Y1 += h;
			procC(i-1);
			canvas.DrawLine(stift, X1, Y1, X1-h, Y1);
			X1 -= h;
			procD(i-1);
		}
		private void procD(int i) {
			if(i == 0) return;
			procA(i-1);
			canvas.DrawLine(stift, X1, Y1, X1, Y1-h);
			Y1 -= h;
			procD(i-1);
			canvas.DrawLine(stift, X1, Y1, X1-h, Y1);
			X1 -= h;
			procD(i-1);
			canvas.DrawLine(stift, X1, Y1, X1, Y1+h);
			Y1 += h;
			procC(i-1);
		}
	}
}
