// --------------------------------------------------------------------------------------
//
// Lissajous.CS                                                    Ulrich Mller 25.01.05
//                                                                 PCS1700       C# Final
// Lissajous Figuren, Markierung der KurvenPunkte durch farbige Quadrate
// zuf : Anzahl Kurven waagerecht / senkrecht, Farben
//
// --------------------------------------------------------------------------------------

using System;
using System.Windows.Forms;
using System.Drawing;

namespace DivGraph
{
	public class Lissajous : UrGraf	{

		const float Kante = 36;

		SolidBrush Farbe;
		Random     rnd = new Random();

		public Lissajous(Control Ausgabe) : base(Ausgabe) {
		}
		public override void Action(Graphics Canvas){

			int   anzX, anzY;
			float X, Y, FakX, FakY, XKor, YKor, Winkel, DeltaW;

			base.canvas = Canvas;
			base.canvas.Clear(base.background);

			anzX = rnd.Next(1, 3);
			anzY = rnd.Next(1, 4);
			FakX = ausgabe.Width / 2 - Kante;
			FakY = ausgabe.Height / 2 - Kante;
			XKor = FakX + Kante / 2;
			YKor = FakY + Kante / 2;
			Winkel = 0;
			DeltaW = (float)(Math.PI / 200);

			do {
				Farbe = new SolidBrush(Color.FromArgb(rnd.Next(0,255),
					rnd.Next(0,255), rnd.Next(0,255)));
				X = (float)(Math.Sin(Winkel * anzX) * FakX + XKor);
				Y = (float)(Math.Cos(Winkel * anzY) * FakY + YKor);
				canvas.FillRectangle(Farbe, X, Y, Kante, Kante);
				Winkel += DeltaW;
			} while(Winkel <= Math.PI * 2);

		} 
	}
}
