// --------------------------------------------------------------------------------------
//
// Pythagoras.CS                                                   Ulrich Mller 23.01.05
//                                                                 PCS1700       C# Final
// Pythagoras-Baum
// nach dpunkt.lehrbuch : Algorithmen und Datenstrukturen
//      3.6.3 Applikative Algorithmen und Rekursion.
//
// --------------------------------------------------------------------------------------

using System;
using System.Windows.Forms;
using System.Drawing;

namespace DivGraph
{
	public class Pythagoras : UrGraf {
		float    breite;
		float    kante;
		float    tanPi;

		public Pythagoras(Control Ausgabe) : base(Ausgabe) {
			breite       = this.ausgabe.Width;
			kante        = breite / 6.25F;
			this.tanPi   = 1.0F;
		}
		public float TanPi {
			get{return tanPi;}
			set{tanPi = value;}
		}

		public override void Action(Graphics Canvas) {
			base.canvas = Canvas;
			base.canvas.Clear(base.background);
			paintTree(this.canvas, breite / 2 - kante / 2,
				                   breite / 5 * 4,
				                   breite / 2 + kante / 2,
				                   breite / 5 * 4); 
		}

		private void paintTree(Graphics g, float x1, float y1, float x2, float y2) {

			float dx = x2 - x1, dy = y1 - y2;
			float x3 = x1 - dy, y3 = y1 - dx;
			float x4 = x2 - dy, y4 = y2 - dx;

			g.DrawLines(stift, new PointF[]{new PointF(x1, y1), new PointF(x2, y2),
											new PointF(x4, y4), new PointF(x3, y3),
											new PointF(x1, y1)});
			if(dx * dx + dy * dy > 2) {
				float v = (x3 + x4) / 2 - (dy / 2 * tanPi);
				float w = (y3 + y4) / 2 - (dx / 2 * tanPi);
				paintTree(g, x3, y3, v, w);
				paintTree(g, v, w, x4, y4);
			}
		}
	}
}
