// --------------------------------------------------------------------------------------
//
// Sierpinski.CS                                                   Ulrich Mller 23.01.05
//                                                                 PCS1700       C# Final
// Sierpinski-Graphik
//
// --------------------------------------------------------------------------------------

using System;
using System.Windows.Forms;
using System.Drawing;

namespace DivGraph
{
	public class Sierpinski : UrGraf {
		int     tiefe, breite;
		float   korr;
		float   H, X0, Y0, X1, Y1;

		public Sierpinski(Control picAus) : base(picAus) {
			tiefe = 5;
			breite = 384;
			korr =(base.ausgabe.Width - breite) / 2;
		}
		public int Tiefe {
			get {return tiefe;}
			set {tiefe = value;}
		}
		public int Breite {
			get {return breite;}
			set {breite = value;
				 korr = (base.ausgabe.Width - breite) / 2;
			}
		}
		public override void Action(Graphics Canvas) {
			base.canvas = Canvas;
			base.canvas.Clear(base.background);
			H = breite / 4;
			X0 = 2 * H + korr;
			Y0 = 3 * H + korr;

			for(int i = 1; i <= tiefe; i++) {
				X0 -= H;
				H = H / 2;
				Y0 += H;
				X1 = X0; 
				Y1 = Y0;
				subA(i);
				canvas.DrawLine(stift, X1, Y1, X1+H, Y1-H);
				X1 += H;
				Y1 -= H;
				subB(i);
				canvas.DrawLine(stift, X1, Y1, X1-H, Y1-H);
				X1 -= H;
				Y1 -= H;
				subC(i);
				canvas.DrawLine(stift, X1, Y1, X1-H, Y1+H);
				X1 -= H;
				Y1 += H;
				subD(i);
				canvas.DrawLine(stift, X1, Y1, X1+H, Y1+H);
			}
		}

		private void subA(int i) {
			if(i < 1) return;
			subA(i-1);
			canvas.DrawLine(stift, X1, Y1, X1+H, Y1-H);
			X1 += H;
			Y1 -= H;
			subB(i-1);
			canvas.DrawLine(stift, X1, Y1, X1+2*H, Y1);
			X1 += 2*H;
			subD(i-1);
			canvas.DrawLine(stift, X1, Y1, X1+H, Y1+H);
			X1 += H;
			Y1 += H;
			subA(i-1);
		}
		private void subB(int i) {
			if(i < 1) return;
			subB(i-1);
			canvas.DrawLine(stift, X1, Y1, X1-H, Y1-H);
			X1 -= H;
			Y1 -= H;
			subC(i-1);
			canvas.DrawLine(stift, X1, Y1, X1, Y1-2*H);
			Y1 -= 2*H;
			subA(i-1);
			canvas.DrawLine(stift, X1, Y1, X1+H, Y1-H);
			X1 += H;
			Y1 -= H;
			subB(i-1);
		}
		private void subC(int i) {
			if(i < 1) return;
			subC(i-1);
			canvas.DrawLine(stift, X1, Y1, X1-H, Y1 +H);
			X1 -= H;
			Y1 += H;
			subD(i-1);
			canvas.DrawLine(stift, X1, Y1, X1-2*H, Y1);
			X1 -= 2*H;
			subB(i-1);
			canvas.DrawLine(stift, X1, Y1, X1-H, Y1-H);
			X1 -= H;
			Y1 -= H;
			subC(i-1);
		}
		private void subD(int i) {
			if(i < 1) return;
			subD(i-1);
			canvas.DrawLine(stift, X1, Y1, X1+H, Y1+H);
			X1 += H;
			Y1 += H;
			subA(i-1);
			canvas.DrawLine(stift, X1, Y1, X1, Y1+2*H);
			Y1 += 2*H;
			subC(i-1);
			canvas.DrawLine(stift, X1, Y1, X1-H, Y1+H);
			X1 -= H;
			Y1 += H;
			subD(i-1);
		}
	}
}
