// --------------------------------------------------------------------------------------
//
// TurtleSierpinski.CS                                             Ulrich Mller 31.01.05
//                                                                 PCS1700       C# Final
// Turtle-Graphik : Sierpinski Graphik
//
// --------------------------------------------------------------------------------------

using System;
using System.Windows.Forms;
using System.Drawing;

namespace DivGraph
{
	public class TurtleSierpinski : Turtle {
		private int N;
		private float H0, H, X0, Y0;
		public TurtleSierpinski(Control Ausgabe) : base(Ausgabe) {}

		public void Action(Graphics Canvas) {
			N  = 4;
			H0 = 384;
			H  = H0 / 4;
			X0 = 0;
			Y0 = 100;
			Bild(Canvas);
			StiftHoch();
			SieRunde(1);
		}

		private void SieRunde(int i) {
			if(i > N) return;
			X0 -= H;
			H  /= 2;
			Y0 += H;
			PenUp(); AufXY(X0, Y0); StiftAb();
			SubA(i); AufXY(XKo()+H, YKo()-H);
			SubB(i); AufXY(XKo()-H, YKo()-H);
			SubC(i); AufXY(XKo()-H, YKo()+H);
			SubD(i); AufXY(XKo()+H, YKo()+H);
			SieRunde(i+1);
		}
		private void SubA(int i) {
			if(i < 1) return;
			SubA(i-1); AufXY(XKo()+H, YKo()-H); StiftAb();
			SubB(i-1); AufX(XKo()+2*H);
			SubD(i-1); AufXY(XKo()+H, YKo()+H);
			SubA(i-1);
		}
		private void SubB(int i) {
			if(i < 1) return;
			SubB(i-1); AufXY(XKo()-H, YKo()-H);
			SubC(i-1); AufY(YKo()-2*H);
			SubA(i-1); AufXY(XKo()+H, YKo()-H);
			SubB(i-1);
		}
		private void SubC(int i) {
			if(i < 1) return;
			SubC(i-1); AufXY(XKo()-H, YKo()+H);
			SubD(i-1); AufX(XKo()-2*H);
			SubB(i-1); AufXY(XKo()-H, YKo()-H);
			SubC(i-1);
		}
		private void SubD(int i) {
			if(i < 1) return;
			SubD(i-1); AufXY(XKo()+H, YKo()+H);
			SubA(i-1); AufY(YKo()+2*H);
			SubC(i-1); AufXY(XKo()-H, YKo()+H);
			SubD(i-1); 
		}
	}
}
